#pragma once

#include "Pokitto.h"

#define SPEED 0.5
#define RANGE 3.0

class Camera
{

private:
    const Fix16 speed=Fix16(SPEED);
    const Fix16 range=Fix16(RANGE);
    bool inRange;
    Fix16 x;
    Fix16 y;
    Fix16 xt;
    Fix16 yt;
    Fix16 dx;
    Fix16 dy;

    int8_t z;

public:


    Camera(int16_t x,int16_t y,int8_t z)
    {
        this->x=xt=fix16_from_int(x);
        this->y=yt=fix16_from_int(y);
        this->z=z;
    }

    void setTarget(int16_t xt,int16_t yt)
    {
        this->xt=fix16_from_int(xt);
        this->yt=fix16_from_int(yt);
    }

    int getX()
    {
        return fix16_to_int(x);
    }

    int getY()
    {
        return fix16_to_int(y);
    }

    int getZ()
    {
        return z;
    }

    void update()
    {
        dx=xt-x;
        dy=yt-y;

        inRange=(x<range && dy<range );

        x+=(dx*speed);
        y+=(dy*speed);
    }

    bool InRange()
    {
        return inRange;
    }

};

